Index: kaffe/kaffevm/classMethod.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/classMethod.c,v
retrieving revision 1.121
diff -u -r1.121 classMethod.c
--- kaffe/kaffevm/classMethod.c	17 Jul 2004 07:57:13 -0000	1.121
+++ kaffe/kaffevm/classMethod.c	7 Aug 2004 09:25:04 -0000
@@ -47,6 +47,7 @@
 #include "debugFile.h"
 #include "jvmpi_kaffe.h"
 #include "kaffe/jmalloc.h"
+#include "methodcalls.h"
 
 #if 0
 #define	METHOD_TRUE_NCODE(METH)			(METH)->c.ncode.ncode_start
@@ -567,7 +568,7 @@
 DBG(STATICINIT,
 			dprintf("using callMethodA\n");
     )
-			callMethodA(meth, METHOD_INDIRECTMETHOD(meth), 0, 0, 0, 1);
+			callMethodA(meth, METHOD_NATIVECODE(meth), 0, 0, 0, 1);
 		}
 
 		lockClass(class);
@@ -1931,112 +1932,6 @@
 	return true;
 }
 
-#if defined(TRANSLATOR)
-/*
- * When do we need a trampoline?
- *
- * NB: this method is invoked for *all* methods a class defines or
- * inherits.
- */
-static bool
-methodNeedsTrampoline(Method *meth)
-{
- 	/* A gcj class's native virtual methods always need a trampoline
-	 * since the gcj trampoline doesn't work for them.  By using a
-	 * trampoline, we can fix the vtable the first time it is invoked.
-	 *
-	 * NB: If we'll ever support CNI, revisit this.
-	 */
-	if (CLASS_GCJ((meth)->class) && (meth->accflags & ACC_NATIVE) &&
-		meth->idx != -1)
-		return (true);
-
-	/* If the method hasn't been translated, we need a trampoline
-	 * NB: we assume the TRANSLATED flag for abstract methods produced
-	 * by gcj is cleared.
-	 */
-	if (!METHOD_TRANSLATED(meth))
-		return (true);
-
-	/* We also need one if it's a static method and the class
-	 * hasn't been initialized, because such method invocation
-	 * would constitute a first active use, requiring the initializer
-	 * to be run.
-	 */
-	if ((meth->accflags & ACC_STATIC)
-		&& meth->class->state < CSTATE_DOING_INIT)
-	{
-		/* Exception: gcj's classes don't need trampolines for two
-		 * reasons:
- 		 *   a) call _Jv_InitClass before invoking any static method.
-		 *   b) they're not compiled as indirect invocations anyway
-		 */
-		if (!CLASS_GCJ(meth->class)) {
-			return (true);
-		}
-	}
-	return (false);
-}
-#endif /* TRANSLATOR */
-
-
-
-/*
- * Build a trampoline if necessary, return the address of the native code
- * to either the trampoline or the translated or native code.
- *
- * Sets *where to the address of the native code.
- *
- * Return the address of the native code or 0 on failure
- */
-static void *
-/* ARGSUSED */
-buildTrampoline(Method *meth, void **where, errorInfo *einfo)
-{
-	void *ret;
-
-#if defined(TRANSLATOR)
-	methodTrampoline *tramp;
-
-	if (methodNeedsTrampoline(meth)) {
-		/* XXX don't forget to pick those up at class gc time */
-		tramp = (methodTrampoline*)gc_malloc(sizeof(methodTrampoline), KGC_ALLOC_TRAMPOLINE);
-		if (tramp == 0) {
-			postOutOfMemory(einfo);
-			return (0);
-		}
-		FILL_IN_TRAMPOLINE(tramp, meth, where);
-
-		/* a disadvantage of building trampolines individually---as
-		 * opposed to allocating them in a contiguous region---is that
-		 * we have flush the dcache individually for each trampoline
-		 */
-		FLUSH_DCACHE(tramp, tramp+1);
-
-		/* for native gcj methods, we do override their
-		 * anchors so we can patch them up before they're invoked.
-		 */
-		if (!(CLASS_GCJ((meth)->class)
-			&& (meth->accflags & ACC_NATIVE)))
-		{
-			assert(*where == 0 ||
-				!!!"Cannot override trampoline anchor");
-		}
-		ret = tramp;
-	} else {
-		if (CLASS_GCJ((meth)->class)) {
-			METHOD_NATIVECODE(meth) = meth->ncode;
-		}
-		assert(METHOD_NATIVECODE(meth) != 0);
-		ret = METHOD_NATIVECODE(meth);
-	}
-#else
-	ret = meth;
-#endif
-	*where = ret;
-	return (ret);
-}
-
 /*
  * Check whether there exists a method with the same name and signature
  * ``meth'' in class ``clazz'' or any of its superclasses.
@@ -2136,7 +2031,7 @@
 		 * point to this trampoline.
 		 */
 		where = (void**)PMETHOD_NATIVECODE(meth);
-		if (buildTrampoline(meth, where, einfo) == 0) {
+		if (engine_buildTrampoline(meth, where, einfo) == 0) {
 			return (false);
 		}
 	}
@@ -2159,7 +2054,7 @@
 			 * but do not update METHOD_NATIVECODE.
 			 */
 			where = &mtab[meth->idx];
-			if (buildTrampoline(meth, where, einfo) == 0) {
+			if (engine_buildTrampoline(meth, where, einfo) == 0) {
 				return (false);
 			}
 		}
@@ -2269,7 +2164,7 @@
 			if (cmeth == 0) {
 				class->itable2dtable[j] = (void *)-1;
 			} else {
-				if (buildTrampoline(cmeth,
+				if (engine_buildTrampoline(cmeth,
 					    class->itable2dtable + j,
 					    einfo) == 0)
 				{
@@ -2473,17 +2368,15 @@
 	for (i = 0; i < CLASS_NMETHODS(class); i++, meth++) {
 		if (meth->accflags & ACC_STATIC) {
 			meth->idx = -1;
-#if defined(TRANSLATOR)
 			/* Handle <clinit> */
 			if (utf8ConstEqual(meth->name, init_name)) {
 				void **where;
 				where = (void**)PMETHOD_NATIVECODE(meth);
 
-				if (buildTrampoline(meth, where, einfo) == 0) {
+				if (engine_buildTrampoline(meth, where, einfo) == 0) {
 					return (false);
 				}
 			}
-#endif
 		}
 		else {
 			meth->idx = class->msize++;
Index: kaffe/kaffevm/classMethod.h
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/classMethod.h,v
retrieving revision 1.67
diff -u -r1.67 classMethod.h
--- kaffe/kaffevm/classMethod.h	2 Aug 2004 10:44:56 -0000	1.67
+++ kaffe/kaffevm/classMethod.h	7 Aug 2004 09:25:05 -0000
@@ -184,14 +184,9 @@
 #define METHOD_TRANSLATED(M)		((M)->accflags & ACC_TRANSLATED)
 #define METHOD_JITTED(M)		((M)->accflags & ACC_JITTED)
 
-#if defined(TRANSLATOR)
 #define	METHOD_NATIVECODE(M)		(((M)->idx == -1) ? \
 		((M)->ncode) : \
 		((M)->class->vtable->method[(M)->idx]))
-#else
-/* INTERPRETER */
-#define	METHOD_NATIVECODE(M)		((M)->ncode)
-#endif
 
 /* Like METHOD_NATIVECODE, except we take the address ---
  * gcc doesn't compile &( ? : ) expressions for some reason
@@ -205,12 +200,6 @@
 					(M)->accflags |= ACC_TRANSLATED
 #define	SET_METHOD_JITCODE(M, C)	METHOD_NATIVECODE(M) = (C); \
 					(M)->accflags |= ACC_TRANSLATED|ACC_JITTED
-
-#if defined(TRANSLATOR)
-#define	METHOD_INDIRECTMETHOD(M)	METHOD_NATIVECODE(M)
-#else
-#define	METHOD_INDIRECTMETHOD(M)	(M)
-#endif
 
 /*
  * Stats for the nameMapping object.
Index: kaffe/kaffevm/code.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/code.c,v
retrieving revision 1.15
diff -u -r1.15 code.c
--- kaffe/kaffevm/code.c	17 Jul 2004 07:57:13 -0000	1.15
+++ kaffe/kaffevm/code.c	7 Aug 2004 09:25:05 -0000
@@ -22,7 +22,6 @@
 #include "object.h"
 #include "classMethod.h"
 #include "readClass.h"
-#include "slots.h"
 #include "exception.h"
 
 bool
Index: kaffe/kaffevm/external.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/external.c,v
retrieving revision 1.67
diff -u -r1.67 external.c
--- kaffe/kaffevm/external.c	25 Jul 2004 06:37:22 -0000	1.67
+++ kaffe/kaffevm/external.c	7 Aug 2004 09:25:05 -0000
@@ -40,7 +40,6 @@
 #include "jthread.h"
 #include "jsignal.h"
 #include "stats.h"
-#include "native-wrapper.h"
 #if defined(KAFFE_FEEDBACK)
 #include "feedback.h"
 #endif
@@ -106,17 +105,6 @@
 
 extern JavaVM Kaffe_JavaVM;
 
-/*
- * Error stub function.  Point unresolved link errors here to avoid
- * problems.
- */
-static
-void*
-error_stub(void)
-{
-	return (0);
-}
-
 #ifdef ENABLE_BINRELOC
 static
 const char *discoverLibraryHome()
@@ -476,7 +464,7 @@
 /*
  * Look up a native function using the JNI interface system.
  */
-static jint
+static nativecode*
 Kaffe_JNI_native(Method* meth)
 {
 	char name[1024];
@@ -500,21 +488,21 @@
 		strcat(name, "__");
 		strcatJNI(name, METHOD_SIGD(meth));
 		func = loadNativeLibrarySym(name);
-		if (func == 0) {
-			return (JNI_FALSE);
-		}
 	}
 
-	meth->accflags |= ACC_JNI;
-
-	/* Wrap the function in a calling wrapper */
-	engine_create_wrapper(meth, func);
+	if (func != NULL) {
+		meth->accflags |= ACC_JNI;
+	}
 
-	return (JNI_TRUE);
+	return (func);
 }
 
-
-bool
+/**
+ * Try to find the native implementation of a java method.
+ *
+ * 
+ */
+nativecode*
 native(Method* m, errorInfo *einfo)
 {
 	char stub[MAXSTUBLEN];
@@ -546,34 +534,24 @@
 
 	/* Find the native method */
 	func = loadNativeLibrarySym(stub);
-	if (func != 0) {
-		/* Fill it in */
-		engine_create_wrapper(m, func);
-		return (true);
+	if (func != NULL) {
+		return (func);
 	}
 
 	/* Try to locate the nature function using the JNI interface */
-        if (Kaffe_JNI_native(m)) {
-                return (true);
+	func = Kaffe_JNI_native(m);
+        if (func != NULL) {
+                return (func);
         }
 
 DBG(NATIVELIB,
 	dprintf("Failed to locate native function:\n\t%s.%s%s\n",
 		m->class->name->data, m->name->data, METHOD_SIGD(m));
     )
-#if defined(TRANSLATOR)
-	{
-		/* Work around for KFREE() ? : bug in gcc 2.7.2 */
-		void *nc = METHOD_NATIVECODE(m);
-		KFREE(nc);
-	}
-#endif
-	SET_METHOD_NATIVECODE(m, (void*)error_stub);
-
 	postExceptionMessage(einfo, JAVA_LANG(UnsatisfiedLinkError),
 		"Failed to locate native function:\t%s.%s%s",
 		m->class->name->data, m->name->data, METHOD_SIGD(m));
-	return (false);
+	return (NULL);
 }
 
 /*
Index: kaffe/kaffevm/external.h
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/external.h,v
retrieving revision 1.7
diff -u -r1.7 external.h
--- kaffe/kaffevm/external.h	3 Apr 2004 02:57:43 -0000	1.7
+++ kaffe/kaffevm/external.h	7 Aug 2004 09:25:05 -0000
@@ -30,7 +30,7 @@
 int	loadNativeLibrary2(char*, int, char*, size_t);
 void	unloadNativeLibrary(int);
 void*	loadNativeLibrarySym(const char*);
-bool	native(struct _methods*, struct _errorInfo*);
+nativecode*	native(struct _methods*, struct _errorInfo*);
 void	addNativeFunc(char*, void*);
 char*	getLibraryPath(void);
 
Index: kaffe/kaffevm/soft.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/soft.c,v
retrieving revision 1.65
diff -u -r1.65 soft.c
--- kaffe/kaffevm/soft.c	25 Jul 2004 16:33:49 -0000	1.65
+++ kaffe/kaffevm/soft.c	7 Aug 2004 09:25:06 -0000
@@ -12,8 +12,6 @@
 #include <stdarg.h>
 
 #include "debug.h"
-#define	TDBG(s)
-
 #include "config.h"
 #include "config-std.h"
 #include "config-math.h"
@@ -567,88 +565,6 @@
 	}
 }
 
-#if defined(TRANSLATOR)
-/*
- * Trampolines come in here - do the translation and replace the trampoline.
- */
-nativecode*
-soft_fixup_trampoline(FIXUP_TRAMPOLINE_DECL)
-{
-	Method* meth;
-	void **where;
-	void *tramp;
-	errorInfo info;
-
-	/* FIXUP_TRAMPOLINE_INIT sets tramp and where */
-	FIXUP_TRAMPOLINE_INIT;
-	tramp = *where;
-
-DBG(MOREJIT,
-	dprintf("soft_fixup_trampoline(): meth %p, where %p\n",
-		meth, where);
-    );
-
-	/* If this class needs initializing, do it now.  */
-	if (meth->class->state < CSTATE_USABLE &&
-		processClass(meth->class, CSTATE_COMPLETE, &info) == false) {
-		throwError(&info);
-	}
-
-	/* Generate code on demand.  */
-	if (!METHOD_TRANSLATED(meth)) {
-		if (translate(meth, &info) == false) {
-			throwError(&info);
-		}
-	}
-
-	/*
-	 * Update the origin of the trampoline and free it if necessary. 
-	 * Another thread might have jumped through the same trampoline
-	 * while we were translating the method, so we have to make this
-	 * atomic.
-	 */
-#if defined(COMPARE_AND_EXCHANGE)
-	if (COMPARE_AND_EXCHANGE(where, tramp, METHOD_NATIVECODE(meth))) {
-		gc_free(tramp);
-	}
-#elif defined(ATOMIC_EXCHANGE)
-	{
-		void *tmp = METHOD_NATIVECODE(meth); 
-
-		ATOMIC_EXCHANGE(where, tmp);
-
-		if (tmp == tramp) {
-			gc_free(tramp);
-		}
-	}
-#else
-#error "You have to define either COMPARE_AND_EXCHANGE or ATOMIC_EXCHANGE"
-#endif
-
-#if 0
-	if (METHOD_PRE_COMPILED(meth)) {
-		nativecode* ncode = METHOD_TRUE_NCODE(meth);
-		nativecode* ocode = METHOD_NATIVECODE(meth);
-		METHOD_NATIVECODE(meth) = ncode;
-		/* Update the dtable entries for all classes if this isn't a
-	   	   static method.  */
-		if (meth->idx >= 0 && ocode != ncode) {
-			meth->class->dtable->method[meth->idx] = ncode;
-		}
-		SET_METHOD_PRE_COMPILED(meth, 0);
-	}
-#endif
-
-TDBG(	dprintf("Calling %s:%s%s @ %p\n", meth->class->name->data, meth->name->data, METHOD_SIGD(meth), METHOD_NATIVECODE(meth));	)
-
-DBG(MOREJIT,
-	dprintf("soft_fixup_trampoline(): return %p\n",
-		METHOD_NATIVECODE(meth));
-    );
-
-	return (METHOD_NATIVECODE(meth));
-}
-#endif
 
 /*
  * Check we can store 'obj' into the 'array'.
Index: kaffe/kaffevm/support.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/support.c,v
retrieving revision 1.71
diff -u -r1.71 support.c
--- kaffe/kaffevm/support.c	2 Aug 2004 10:44:56 -0000	1.71
+++ kaffe/kaffevm/support.c	7 Aug 2004 09:25:07 -0000
@@ -39,6 +39,8 @@
 #include "thread.h"
 #include "jthread.h"
 #include "locks.h"
+#include "methodcalls.h"
+#include "native.h"
 
 #if !defined(HAVE_GETTIMEOFDAY)
 #include <sys/timeb.h>
@@ -152,7 +154,7 @@
 		throwException(NoSuchMethodError(method_name));
 	}
 
-	callMethodV(mb, METHOD_INDIRECTMETHOD(mb), obj, argptr, &retval);
+	callMethodV(mb, METHOD_NATIVECODE(mb), obj, argptr, &retval);
 
 	return (retval);
 }
@@ -228,7 +230,7 @@
 	}
 
 	/* Make the call */
-	callMethodV(mb, METHOD_INDIRECTMETHOD(mb), 0, argptr, &retval);
+	callMethodV(mb, METHOD_NATIVECODE(mb), 0, argptr, &retval);
 
 	return (retval);
 }
@@ -317,7 +319,7 @@
 	assert(obj != 0);
 
 	/* Make the call */
-	callMethodV(mb, METHOD_INDIRECTMETHOD(mb), obj, argptr, &retval);
+	callMethodV(mb, METHOD_NATIVECODE(mb), obj, argptr, &retval);
 
 	return (obj);
 }
@@ -434,54 +436,18 @@
 	int i;
 	int j;
 	int s;
-	/* XXX call.callsize and call.calltype arrays are statically sized 
-	   and are not checked for running out of bounds */
 	callMethodInfo call;	
-	jvalue in[MAXMARGS];
 	jvalue tmp;
 
 	if (ret == 0) {
 		ret = &tmp;
 	}
-	i = 0;
+	i = engine_reservedArgs(meth);
 	s = 0;
-
-#if defined(INTERPRETER)
-	/*
-	 * If the method is native, we must find it so that we know whether
-	 * it is a JNI method or not.  If it is one, ACC_JNI will be set
-	 * upon return from native and we will add additional parameters 
-	 * according to the JNI calling convention.
-	 */
-	meth = (Method*)func;
-	if (meth->accflags & ACC_NATIVE) {
-		if (!METHOD_TRANSLATED(meth)) {
-			errorInfo info;
-			if (native(meth, &info) == false) {
-				throwError(&info);
-			}
-		}
-		call.function = METHOD_NATIVECODE(meth);
-	}
-
-	/* Insert the JNI environment */
-	if (meth->accflags & ACC_JNI) {
-		call.callsize[i] = PTR_TYPE_SIZE / SIZEOF_INT;
-		call.calltype[i] = 'L';
-		in[i].l = THREAD_JNIENV(); 
-		s += call.callsize[i];
-		i++;
-
-		/* If method is static we must insert the class as an argument */
-		if (meth->accflags & ACC_STATIC) {
-			call.callsize[i] = PTR_TYPE_SIZE / SIZEOF_INT;
-			s += call.callsize[i];
-			call.calltype[i] = 'L';
-			in[i].l = meth->class;
-			i++;
-		}
-	} 
-#endif
+	
+	call.args = (jvalue *)alloca((METHOD_NARGS(meth)+engine_reservedArgs(meth)+2)*(sizeof(jvalue)+2));
+	call.callsize = (char *)&call.args[METHOD_NARGS(meth)+engine_reservedArgs(meth)+2];
+	call.calltype = (char *)&call.callsize[METHOD_NARGS(meth)+engine_reservedArgs(meth)+2];
 
 	/* If this method isn't static, we must insert the object as
 	 * an argument.
@@ -490,7 +456,7 @@
 		call.callsize[i] = PTR_TYPE_SIZE / SIZEOF_INT;
 		s += call.callsize[i];
 		call.calltype[i] = 'L';
-		in[i].l = obj;
+		call.args[i].l = obj;
 		i++;
 	}
 
@@ -500,30 +466,30 @@
 		case 'Z':
 			if (promoted) goto use_int;
 			call.callsize[i] = 1;
-			in[i].PROM_i = args[j].z;
+			call.args[i].PROM_i = args[j].z;
 			break;
 
 		case 'S':
 			if (promoted) goto use_int;
 			call.callsize[i] = 1;
-			in[i].PROM_i = args[j].s;
+			call.args[i].PROM_i = args[j].s;
 			break;
 
 		case 'B':
 			if (promoted) goto use_int;
 			call.callsize[i] = 1;
-			in[i].PROM_i = args[j].b;
+			call.args[i].PROM_i = args[j].b;
 			break;
 
 		case 'C':
 			if (promoted) goto use_int;
 			call.callsize[i] = 1;
-			in[i].PROM_i = args[j].c;
+			call.args[i].PROM_i = args[j].c;
 			break;
 
 		case 'F':
 			call.callsize[i] = 1;
-			in[i].PROM_f = args[j].f;
+			call.args[i].PROM_f = args[j].f;
 			if (PROMOTE_jfloat2jdouble) {
 				call.calltype[i] = 'D';
 			}
@@ -531,19 +497,19 @@
 		case 'I':
 		use_int:
 			call.callsize[i] = 1;
-			in[i].PROM_i = args[j].i;
+			call.args[i].PROM_i = args[j].i;
 			break;
 		case 'D':
 		case 'J':
 			call.callsize[i] = 2;
 			ENSURE_ALIGN64({});
-			in[i] = args[j];
+			call.args[i] = args[j];
 			if (promoted) { /* compensate for the second array element by incrementing args */
 			  args++;
 			}
 			if (! NO_HOLES) {
 				s += call.callsize[i];
-				in[i+1].i = (&in[i].i)[1];
+				call.args[i+1].i = (&call.args[i].i)[1];
 				i++; 
 				call.calltype[i] = 0;
 				call.callsize[i] = 0;
@@ -554,7 +520,7 @@
 			/* fall through */
 		case 'L':
 			call.callsize[i] = PTR_TYPE_SIZE / SIZEOF_INT;
-			in[i] = args[j];
+			call.args[i] = args[j];
 			break;
 		default:
 			ABORT();
@@ -565,7 +531,7 @@
 #if defined(STACK_LIMIT)
 	call.calltype[i] = 'L';
 	call.callsize[i] = PTR_TYPE_SIZE / SIZEOF_INT;
-	in[i].l = jthread_stacklimit();
+	call.args[i].l = jthread_stacklimit();
 	s += PTR_TYPE_SIZE / SIZEOF_INT;
 	i++;
 #endif
@@ -594,11 +560,7 @@
 	/* Call info and arguments */
 	call.nrargs = i;
 	call.argsize = s;
-	call.args = in;
 	call.ret = ret;
-
-
-#if defined(TRANSLATOR)
 	call.function = func;
 
 	/* GCDIAG wipes free memory with 0xf4... */
@@ -606,82 +568,7 @@
 	assert(*(uint32*)(call.function) != 0xf4f4f4f4);
 
 	/* Make the call - system dependent */
-	sysdepCallMethod(&call);
-#endif
-#if defined(INTERPRETER)
-	if ((meth->accflags & ACC_NATIVE) == 0) {
-		virtualMachine(meth, (slots*)call.args, (slots*)call.ret, THREAD_DATA()); 
-	}
-	else {
-		Hjava_lang_Object* syncobj = 0;
-		VmExceptHandler mjbuf;
-		threadData* thread_data = THREAD_DATA(); 
-		struct Hjava_lang_Throwable *save_except = NULL;
-
-		if (meth->accflags & ACC_SYNCHRONISED) {
-			if (meth->accflags & ACC_STATIC) {
-				syncobj = &meth->class->head;
-			}
-			else {
-				syncobj = (Hjava_lang_Object*)call.args[0].l;
-			}
-			lockObject(syncobj);
-		}
-
-		setupExceptionHandling(&mjbuf, meth, syncobj, thread_data);
-
-		/* This exception has yet been handled by the VM creator.
-		 * We are putting it in stand by until it is cleared. For
-		 * that JNI call we're cleaning up the pointer and we will
-		 * put it again to the value afterward.
-		 */
-		if ((meth->accflags & ACC_JNI) != 0) {
-			if (thread_data->exceptObj != NULL)
-				save_except = thread_data->exceptObj;
-			else
-				save_except = NULL;
-			thread_data->exceptObj = NULL;
-		}
-			
-		/* Make the call - system dependent */
-		sysdepCallMethod(&call);
-
-		if (syncobj != 0) {
-			unlockObject(syncobj);
-		}
-
-		/* If we have a pending exception and this is JNI, throw it */
-		if ((meth->accflags & ACC_JNI) != 0) {
-			struct Hjava_lang_Throwable *eobj;
-			
-			eobj = thread_data->exceptObj;
-			if (eobj != 0) {
-				thread_data->exceptObj = 0;
-				throwExternalException(eobj);
-			}
-			thread_data->exceptObj = save_except;
-		}
-
-		cleanupExceptionHandling(&mjbuf, thread_data);
-
-	}
-#endif
-	if (!promoted && call.retsize == 1) {
-		switch (call.rettype) {
-		case 'Z':
-			ret->z = ret->i;
-			break;
-		case 'S':
-			ret->s = ret->i;
-			break;
-		case 'B':
-			ret->b = ret->i;
-			break;
-		case 'C':
-			ret->c = ret->i;
-			break;
-		}
-	}
+	engine_callMethod(&call);
 }
 
 /**
@@ -700,50 +587,18 @@
 	int i;
 	int s;
 	int j;
-	/* XXX call.callsize and call.calltype arrays are statically sized 
-	   and are not checked for running out of bounds */
 	callMethodInfo call;
-	jvalue in[MAXMARGS];
 	jvalue tmp;
 
 	if (ret == 0) {
 		ret = &tmp;
 	}
-	i = 0;
+	i = engine_reservedArgs(meth);
 	s = 0;
 
-#if defined(INTERPRETER)
-	meth = (Method*)func;
-	if (meth->accflags & ACC_NATIVE) {
-                if (METHOD_NATIVECODE(meth) == 0) {
-			errorInfo info;
-			if (native(meth, &info) == false) {
-				throwError(&info);
-			}
-                }
-		call.function = METHOD_NATIVECODE(meth);
-	}
-
-	/* Insert the JNI environment */
-	if (meth->accflags & ACC_JNI) {
-		call.callsize[i] = PTR_TYPE_SIZE / SIZEOF_INT;
-		call.calltype[i] = 'L';
-		in[i].l = THREAD_JNIENV(); 
-		s += call.callsize[i];
-		i++;
-
-		/* If method is static we must insert the class as an 
-		 * argument 
-		 */
-		if (meth->accflags & ACC_STATIC) {
-			call.callsize[i] = PTR_TYPE_SIZE / SIZEOF_INT;
-			s += call.callsize[i];
-			call.calltype[i] = 'L';
-			in[i].l = meth->class;
-			i++;
-		}
-	}
-#endif
+	call.args = (jvalue *)alloca((METHOD_NARGS(meth)+engine_reservedArgs(meth)+2)*(sizeof(jvalue)+2));
+	call.callsize = (char *)&call.args[METHOD_NARGS(meth)+engine_reservedArgs(meth)+2];
+	call.calltype = (char *)&call.callsize[METHOD_NARGS(meth)+engine_reservedArgs(meth)+2];
 
 	/* If this method isn't static, we must insert the object as
 	 * the first argument and get the function code.
@@ -752,7 +607,7 @@
 		call.callsize[i] = PTR_TYPE_SIZE / SIZEOF_INT;
 		s += call.callsize[i];
 		call.calltype[i] = 'L';
-		in[i].l = obj;
+		call.args[i].l = obj;
 		i++;
 	}
 
@@ -765,11 +620,11 @@
 		case 'B':
 		case 'C':
 			call.callsize[i] = 1;
-			in[i].PROM_i = va_arg(args, jint);
+			call.args[i].PROM_i = va_arg(args, jint);
 			break;
 		case 'F':
 			call.callsize[i] = 1;
-			in[i].PROM_f = (jfloat)va_arg(args, jdouble);
+			call.args[i].PROM_f = (jfloat)va_arg(args, jdouble);
 			if (PROMOTE_jfloat2jdouble) {
 				call.calltype[i] = 'D';
 			}
@@ -777,16 +632,16 @@
 		case 'D':
 			call.callsize[i] = 2;
 			ENSURE_ALIGN64({});
-			in[i].d = va_arg(args, jdouble);
+			call.args[i].d = va_arg(args, jdouble);
 			goto second_word;
 		case 'J':
 			call.callsize[i] = 2;
 			ENSURE_ALIGN64({});
-			in[i].j = va_arg(args, jlong);
+			call.args[i].j = va_arg(args, jlong);
 		second_word:
 			if(! NO_HOLES) {
 				s += call.callsize[i];
-				in[i+1].i = (&in[i].i)[1];
+				call.args[i+1].i = (&call.args[i].i)[1];
 				i++;
 				call.callsize[i] = 0;
 			}
@@ -796,7 +651,7 @@
 			/* fall through */
 		case 'L':
 			call.callsize[i] = PTR_TYPE_SIZE / SIZEOF_INT;
-			in[i].l = va_arg(args, jref);
+			call.args[i].l = va_arg(args, jref);
 			break;
 		default:
 			ABORT();
@@ -807,7 +662,7 @@
 #if defined(STACK_LIMIT)
 	call.calltype[i] = 'L';
 	call.callsize[i] = PTR_TYPE_SIZE / SIZEOF_INT;
-	in[i].l = jthread_stacklimit();
+	call.args[i].l = jthread_stacklimit();
 	s += PTR_TYPE_SIZE / SIZEOF_INT;
 	i++;
 #endif
@@ -836,10 +691,7 @@
 	/* Call info and arguments */
 	call.nrargs = i;
 	call.argsize = s;
-	call.args = in;
 	call.ret = ret;
-
-#if defined(TRANSLATOR)
 	call.function = func;
 
 	/* GCDIAG wipes free memory with 0xf4... */
@@ -847,65 +699,7 @@
 	assert(*(uint32*)(call.function) != 0xf4f4f4f4);
 
 	/* Make the call - system dependent */
-	sysdepCallMethod(&call);
-#endif
-#if defined(INTERPRETER)
-	if ((meth->accflags & ACC_NATIVE) == 0) {
-		virtualMachine(meth, (slots*)call.args, (slots*)call.ret, THREAD_DATA()); 
-	}
-	else {
-		Hjava_lang_Object* syncobj = 0;
-		VmExceptHandler mjbuf;
-		threadData* thread_data = THREAD_DATA(); 
-		struct Hjava_lang_Throwable *save_except = NULL;
-
-		if (meth->accflags & ACC_SYNCHRONISED) {
-			if (meth->accflags & ACC_STATIC) {
-				syncobj = &meth->class->head;
-			}
-			else {
-				syncobj = (Hjava_lang_Object*)call.args[0].l;
-			}
-			lockObject(syncobj);
-		}
-
-		setupExceptionHandling(&mjbuf, meth, syncobj, thread_data);
-
-		/* This exception has yet been handled by the VM creator.
-		 * We are putting it in stand by until it is cleared. For
-		 * that JNI call we're cleaning up the pointer and we will
-		 * put it again to the value afterward.
-		 */
-		if ((meth->accflags & ACC_JNI) != 0) {
-			if (thread_data->exceptObj != NULL)
-				save_except = thread_data->exceptObj;
-			else
-				save_except = NULL;
-			thread_data->exceptObj = NULL;
-		}
-
-		/* Make the call - system dependent */
-		sysdepCallMethod(&call);
-
-		if (syncobj != 0) {
-			unlockObject(syncobj);
-		}
-
-		/* If we have a pending exception and this is JNI, throw it */
-		if ((meth->accflags & ACC_JNI) != 0) {
-			struct Hjava_lang_Throwable *eobj;
-
-			eobj = thread_data->exceptObj;
-			if (eobj != 0) {
-				thread_data->exceptObj = 0;
-				throwExternalException(eobj);
-			}
-			thread_data->exceptObj = save_except;
-		}
-
-		cleanupExceptionHandling(&mjbuf, thread_data);
-	}
-#endif
+	engine_callMethod(&call);
 }
 
 /**
Index: kaffe/kaffevm/support.h
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/support.h,v
retrieving revision 1.32
diff -u -r1.32 support.h
--- kaffe/kaffevm/support.h	26 May 2004 21:19:29 -0000	1.32
+++ kaffe/kaffevm/support.h	7 Aug 2004 09:25:07 -0000
@@ -97,8 +97,8 @@
 	int			argsize;
 	char			retsize;
 	char			rettype;
-	char			callsize[MAXMARGS];
-	char			calltype[MAXMARGS];
+	char			*callsize;
+	char			*calltype;
 } callMethodInfo;
 
 struct Hjava_lang_String;
Index: kaffe/kaffevm/intrp/Makefile.am
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/intrp/Makefile.am,v
retrieving revision 1.10
diff -u -r1.10 Makefile.am
--- kaffe/kaffevm/intrp/Makefile.am	27 Jun 2004 12:08:33 -0000	1.10
+++ kaffe/kaffevm/intrp/Makefile.am	7 Aug 2004 09:25:07 -0000
@@ -23,7 +23,8 @@
 
 libengine_la_SOURCES = \
 	machine.c \
-	native-wrapper.c
+	native-wrapper.c \
+	methodcalls.c
 
 EXTRA_DIST = \
 	Makefile.frag \
@@ -32,4 +33,5 @@
 	machine.h \
 	slots.h \
 	stackTrace-impl.h \
-	native-wrapper.h
+	native-wrapper.h \
+	methodcalls.h
Index: kaffe/kaffevm/intrp/Makefile.in
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/intrp/Makefile.in,v
retrieving revision 1.114
diff -u -r1.114 Makefile.in
--- kaffe/kaffevm/intrp/Makefile.in	30 Jul 2004 11:06:23 -0000	1.114
+++ kaffe/kaffevm/intrp/Makefile.in	7 Aug 2004 09:25:07 -0000
@@ -74,7 +74,7 @@
 CONFIG_CLEAN_FILES =
 LTLIBRARIES = $(noinst_LTLIBRARIES)
 libengine_la_LIBADD =
-am_libengine_la_OBJECTS = machine.lo native-wrapper.lo
+am_libengine_la_OBJECTS = machine.lo native-wrapper.lo methodcalls.lo
 libengine_la_OBJECTS = $(am_libengine_la_OBJECTS)
 DEFAULT_INCLUDES = -I. -I$(srcdir) -I$(top_builddir)/config -I$(top_builddir)/include/kaffe
 depcomp = $(SHELL) $(top_srcdir)/scripts/depcomp
@@ -361,7 +361,8 @@
 
 libengine_la_SOURCES = \
 	machine.c \
-	native-wrapper.c
+	native-wrapper.c \
+	methodcalls.c
 
 EXTRA_DIST = \
 	Makefile.frag \
@@ -370,7 +371,8 @@
 	machine.h \
 	slots.h \
 	stackTrace-impl.h \
-	native-wrapper.h
+	native-wrapper.h \
+	methodcalls.h
 
 all: all-am
 
@@ -425,6 +427,7 @@
 
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/machine.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/native-wrapper.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/methodcalls.Plo@am__quote@
 
 .c.o:
 @am__fastdepCC_TRUE@	if $(COMPILE) -MT $@ -MD -MP -MF "$(DEPDIR)/$*.Tpo" -c -o $@ $<; \
Index: kaffe/kaffevm/intrp/methodcalls.c
===================================================================
RCS file: kaffe/kaffevm/intrp/methodcalls.c
diff -N kaffe/kaffevm/intrp/methodcalls.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ kaffe/kaffevm/intrp/methodcalls.c	7 Aug 2004 09:25:07 -0000
@@ -0,0 +1,122 @@
+
+#define NEED_sysdepCallMethod 1
+#include "methodcalls.h"
+#include "thread.h"
+#include "slots.h"
+
+void *
+engine_buildTrampoline (Method *meth, void **where, errorInfo *einfo UNUSED)
+{
+	*where = meth;
+	return meth;
+}
+
+void
+engine_callMethod (callMethodInfo *call)
+{
+	Method *meth = (Method *)call->function;
+
+	if ((meth->accflags & ACC_NATIVE) == 0) {
+		virtualMachine(meth, (slots*)(call->args+2), (slots*)call->ret, THREAD_DATA()); 
+	}
+	else {
+		Hjava_lang_Object* syncobj = 0;
+		VmExceptHandler mjbuf;
+		threadData* thread_data = THREAD_DATA(); 
+		struct Hjava_lang_Throwable *save_except = NULL;
+		errorInfo einfo;
+
+		if (!METHOD_TRANSLATED(meth)) {
+			void *func = native(meth, &einfo);
+			if (func == NULL) {
+				throwError(&einfo);
+			}
+			METHOD_CODE_START(meth) = func;
+			meth->accflags |= ACC_TRANSLATED;
+		}
+
+		call->function = METHOD_CODE_START(meth);
+
+		if (meth->accflags & ACC_JNI)
+		{
+			if (meth->accflags & ACC_STATIC)
+			{
+				call->callsize[1] = PTR_TYPE_SIZE / SIZEOF_INT;
+				call->argsize += call->callsize[1];
+				call->calltype[1] = 'L';
+				call->args[1].l = meth->class;
+			}
+			else
+			{
+				call->nrargs -= 1;
+				call->args += 1;
+				call->callsize += 1;
+				call->calltype += 1;
+			}
+
+			/* Insert the JNI environment */
+			call->callsize[0] = PTR_TYPE_SIZE / SIZEOF_INT;
+			call->calltype[0] = 'L';
+			call->args[0].l = THREAD_JNIENV(); 
+			call->argsize += call->callsize[0]; 
+		}
+		else
+		{
+			call->nrargs -= 2;
+			call->args += 2;
+			call->callsize += 2;
+			call->calltype += 2;
+		}
+
+		if (meth->accflags & ACC_SYNCHRONISED) {
+			if (meth->accflags & ACC_STATIC) {
+				syncobj = &meth->class->head;
+			}
+			else if (meth->accflags & ACC_JNI) {
+				syncobj = (Hjava_lang_Object*)call->args[1].l;
+			}
+			else {
+				syncobj = (Hjava_lang_Object*)call->args[0].l;
+			}
+
+			lockObject(syncobj);
+		}
+
+		setupExceptionHandling(&mjbuf, meth, syncobj, thread_data);
+
+		/* This exception has yet been handled by the VM creator.
+		 * We are putting it in stand by until it is cleared. For
+		 * that JNI call we're cleaning up the pointer and we will
+		 * put it again to the value afterward.
+		 */
+		if ((meth->accflags & ACC_JNI) != 0) {
+			if (thread_data->exceptObj != NULL)
+				save_except = thread_data->exceptObj;
+			else
+				save_except = NULL;
+			thread_data->exceptObj = NULL;
+		}
+
+		/* Make the call - system dependent */
+		sysdepCallMethod(call);
+
+		if (syncobj != 0) {
+			unlockObject(syncobj);
+		}
+
+		/* If we have a pending exception and this is JNI, throw it */
+		if ((meth->accflags & ACC_JNI) != 0) {
+			struct Hjava_lang_Throwable *eobj;
+
+			eobj = thread_data->exceptObj;
+			if (eobj != 0) {
+				thread_data->exceptObj = 0;
+				throwExternalException(eobj);
+			}
+			thread_data->exceptObj = save_except;
+		}
+
+		cleanupExceptionHandling(&mjbuf, thread_data);
+	}
+
+}
Index: kaffe/kaffevm/intrp/methodcalls.h
===================================================================
RCS file: kaffe/kaffevm/intrp/methodcalls.h
diff -N kaffe/kaffevm/intrp/methodcalls.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ kaffe/kaffevm/intrp/methodcalls.h	7 Aug 2004 09:25:07 -0000
@@ -0,0 +1,18 @@
+
+#ifndef __method_calls_h__
+#define __method_calls_h__
+
+#include "classMethod.h"
+#include "support.h"
+
+void *
+engine_buildTrampoline (Method *meth, void **where, errorInfo *einfo);
+
+void engine_callMethod (callMethodInfo *call);
+
+/*
+ * extra args the engine wants to pass when using callMethodA / callMethodV
+ */
+#define engine_reservedArgs(M) 2
+
+#endif /* __method_dispatch_h__ */
Index: kaffe/kaffevm/intrp/native-wrapper.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/intrp/native-wrapper.c,v
retrieving revision 1.2
diff -u -r1.2 native-wrapper.c
--- kaffe/kaffevm/intrp/native-wrapper.c	5 Jul 2004 16:40:42 -0000	1.2
+++ kaffe/kaffevm/intrp/native-wrapper.c	7 Aug 2004 09:25:07 -0000
@@ -20,6 +20,6 @@
 void
 engine_create_wrapper (Method *meth, void *func)
 {
-	SET_METHOD_NATIVECODE(meth, func);
+	METHOD_CODE_START(meth) = func;
 	return meth;
 }
Index: kaffe/kaffevm/jit/Makefile.am
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/jit/Makefile.am,v
retrieving revision 1.16
diff -u -r1.16 Makefile.am
--- kaffe/kaffevm/jit/Makefile.am	27 Jun 2004 12:08:35 -0000	1.16
+++ kaffe/kaffevm/jit/Makefile.am	7 Aug 2004 09:25:08 -0000
@@ -31,7 +31,8 @@
 	slots.c \
 	machine.c \
 	seq.c \
-	native-wrapper.c
+	native-wrapper.c \
+	methodcalls.c
 
 EXTRA_DIST = \
 	Makefile.frag \
@@ -46,7 +47,8 @@
 	seq.h \
 	slots.h \
 	stackTrace-impl.h \
-	native-wrapper.h
+	native-wrapper.h \
+	methodcalls.h
 
 DISTCLEANFILES = icode.h jit.def trampolines.c
 
Index: kaffe/kaffevm/jit/Makefile.in
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/jit/Makefile.in,v
retrieving revision 1.120
diff -u -r1.120 Makefile.in
--- kaffe/kaffevm/jit/Makefile.in	30 Jul 2004 11:06:24 -0000	1.120
+++ kaffe/kaffevm/jit/Makefile.in	7 Aug 2004 09:25:08 -0000
@@ -76,7 +76,7 @@
 libengine_la_LIBADD =
 am_libengine_la_OBJECTS = basecode.lo constpool.lo funcs.lo icode.lo \
 	labels.lo registers.lo slots.lo machine.lo seq.lo \
-	native-wrapper.lo
+	native-wrapper.lo methodcalls.lo
 libengine_la_OBJECTS = $(am_libengine_la_OBJECTS)
 DEFAULT_INCLUDES = -I. -I$(srcdir) -I$(top_builddir)/config -I$(top_builddir)/include/kaffe
 depcomp = $(SHELL) $(top_srcdir)/scripts/depcomp
@@ -371,7 +371,8 @@
 	slots.c \
 	machine.c \
 	seq.c \
-	native-wrapper.c
+	native-wrapper.c \
+	methodcalls.c
 
 EXTRA_DIST = \
 	Makefile.frag \
@@ -386,7 +387,8 @@
 	seq.h \
 	slots.h \
 	stackTrace-impl.h \
-	native-wrapper.h
+	native-wrapper.h \
+	methodcalls.h
 
 DISTCLEANFILES = icode.h jit.def trampolines.c
 all: all-am
@@ -446,6 +448,7 @@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/icode.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/labels.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/machine.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/methodcalls.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/native-wrapper.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/registers.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/seq.Plo@am__quote@
Index: kaffe/kaffevm/jit/funcs.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/jit/funcs.c,v
retrieving revision 1.4
diff -u -r1.4 funcs.c
--- kaffe/kaffevm/jit/funcs.c	13 Jul 2004 14:17:04 -0000	1.4
+++ kaffe/kaffevm/jit/funcs.c	7 Aug 2004 09:25:08 -0000
@@ -64,4 +64,3 @@
 #endif
 
 #include "jit.def"
-#include "trampolines.c"
Index: kaffe/kaffevm/jit/machine.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/jit/machine.c,v
retrieving revision 1.68
diff -u -r1.68 machine.c
--- kaffe/kaffevm/jit/machine.c	17 Jul 2004 07:57:28 -0000	1.68
+++ kaffe/kaffevm/jit/machine.c	7 Aug 2004 09:25:08 -0000
@@ -48,6 +48,7 @@
 #include "jthread.h"
 #include "stats.h"
 #include "support.h"
+#include "native-wrapper.h"
 
 /*
  * Define information about this engine.
@@ -225,10 +226,13 @@
 
 	/* If this code block is native, then just set it up and return */
 	if ((meth->accflags & ACC_NATIVE) != 0) {
-		success = native(meth, einfo);
-		if (success == false) {
+		void *func = native(meth, einfo);
+
+		if (func == NULL) {
+			success = false;
 			goto done3;
 		}
+		engine_create_wrapper(meth, func);
 		KAFFEJIT_TO_NATIVE(meth);
 		/* Note that this is a real function not a trampoline.  */
 		if (meth->c.ncode.ncode_end == 0)
@@ -237,7 +241,7 @@
 	}
 
 	/* Scan the code and determine the basic blocks */
-	success = analyzeMethod(meth, &codeInfo, einfo);
+	success = analyzeMethod(meth, &codeInfo, einfo); 
 	if (success == false) {
 		goto done3;
 	}
@@ -300,9 +304,9 @@
 	/***************************************/
 	/* Next reduce bytecode to native code */
 	/***************************************/
-
-	if (!(success = initInsnSequence(meth, codeperbytecode * len, meth->localsz,
-					 meth->stacksz, einfo))) {
+	success = initInsnSequence(meth, codeperbytecode * len, meth->localsz,
+				   meth->stacksz, einfo);
+	if (success == false) {
 		goto done1;
 	}
 
@@ -384,8 +388,8 @@
 
 	assert(maxTemp < MAXTEMPS);
 
-	if (finishInsnSequence(codeInfo, &ncode, einfo) == false) {
-		success = false;
+	success = finishInsnSequence(codeInfo, &ncode, einfo);
+	if (success == false) {
 		goto done;
 	}
 	installMethodCode(codeInfo, meth, &ncode);
@@ -396,7 +400,7 @@
 DBG(JIT,
 	dprintf("Translated %s.%s%s (%s) %p\n", meth->class->name->data, 
 		meth->name->data, METHOD_SIGD(meth), 
-		isStatic ? "static" : "normal", meth->ncode);	
+		isStatic ? "static" : "normal", METHOD_NATIVECODE(meth));	
     )
 
 	if (Kaffe_JavaVMArgs.enableVerboseJIT) {
Index: kaffe/kaffevm/jit/methodcalls.c
===================================================================
RCS file: kaffe/kaffevm/jit/methodcalls.c
diff -N kaffe/kaffevm/jit/methodcalls.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ kaffe/kaffevm/jit/methodcalls.c	7 Aug 2004 09:25:08 -0000
@@ -0,0 +1,182 @@
+
+#define NEED_sysdepCallMethod 1
+#include "methodcalls.h"
+
+#define TDBG(s)
+
+/*
+ * Trampolines come in here - do the translation and replace the trampoline.
+ */
+static nativecode*
+soft_fixup_trampoline(FIXUP_TRAMPOLINE_DECL)
+{
+	Method* meth;
+	void **where;
+	void *tramp;
+	errorInfo info;
+
+	/* FIXUP_TRAMPOLINE_INIT sets tramp and where */
+	FIXUP_TRAMPOLINE_INIT;
+	tramp = *where;
+
+DBG(MOREJIT,
+	dprintf("soft_fixup_trampoline(): meth %p, where %p, native code %p\n",
+		meth, where, PMETHOD_NATIVECODE(meth));
+    );
+
+	/* If this class needs initializing, do it now.  */
+	if (meth->class->state != CSTATE_COMPLETE &&
+		processClass(meth->class, CSTATE_COMPLETE, &info) == false) {
+		throwError(&info);
+	}
+
+	/* Generate code on demand.  */
+	if (!METHOD_TRANSLATED(meth)) {
+		if (!translate(meth, &info)) {
+			throwError(&info);
+		}
+	}
+
+	/*
+	 * Update the origin of the trampoline and free it if necessary. 
+	 * Another thread might have jumped through the same trampoline
+	 * while we were translating the method, so we have to make this
+	 * atomic.
+	 */
+#if defined(COMPARE_AND_EXCHANGE)
+	if (COMPARE_AND_EXCHANGE(where, tramp, METHOD_NATIVECODE(meth))) {
+		gc_free(tramp);
+	}
+#elif defined(ATOMIC_EXCHANGE)
+	{
+		void *tmp = METHOD_NATIVECODE(meth);
+
+		ATOMIC_EXCHANGE(where, tmp);
+
+		if (tmp == tramp) {
+			gc_free(tramp);
+		}
+	}
+#else
+#error "You have to define either COMPARE_AND_EXCHANGE or ATOMIC_EXCHANGE"
+#endif
+
+#if 0
+	if (METHOD_PRE_COMPILED(meth)) {
+		nativecode* ncode = METHOD_TRUE_NCODE(meth);
+		nativecode* ocode = METHOD_NATIVECODE(meth);
+		METHOD_NATIVECODE(meth) = ncode;
+		/* Update the dtable entries for all classes if this isn't a
+	   	   static method.  */
+		if (meth->idx >= 0 && ocode != ncode) {
+			meth->class->dtable->method[meth->idx] = ncode;
+		}
+		SET_METHOD_PRE_COMPILED(meth, 0);
+	}
+#endif
+
+TDBG(	dprintf("Calling %s:%s%s @ %p\n", meth->class->name->data, meth->name->data, METHOD_SIGD(meth), METHOD_NATIVECODE(meth));	)
+
+DBG(MOREJIT,
+	dprintf("soft_fixup_trampoline(): return %p\n",
+		METHOD_NATIVECODE(meth));
+    );
+
+	return (METHOD_NATIVECODE(meth));
+}
+
+#include "trampolines.c"
+
+/*
+ * When do we need a trampoline?
+ *
+ * NB: this method is invoked for *all* methods a class defines or
+ * inherits.
+ */
+static bool
+methodNeedsTrampoline(Method *meth)
+{
+ 	/* A gcj class's native virtual methods always need a trampoline
+	 * since the gcj trampoline doesn't work for them.  By using a
+	 * trampoline, we can fix the vtable the first time it is invoked.
+	 *
+	 * NB: If we'll ever support CNI, revisit this.
+	 */
+	if (CLASS_GCJ((meth)->class) && (meth->accflags & ACC_NATIVE) &&
+		meth->idx != -1)
+		return (true);
+
+	/* If the method hasn't been translated, we need a trampoline
+	 * NB: we assume the TRANSLATED flag for abstract methods produced
+	 * by gcj is cleared.
+	 */
+	if (!METHOD_TRANSLATED(meth))
+		return (true);
+
+	/* We also need one if it's a static method and the class
+	 * hasn't been initialized, because such method invocation
+	 * would constitute a first active use, requiring the initializer
+	 * to be run.
+	 */
+	if ((meth->accflags & ACC_STATIC)
+		&& meth->class->state < CSTATE_DOING_INIT)
+	{
+		/* Exception: gcj's classes don't need trampolines for two
+		 * reasons:
+ 		 *   a) call _Jv_InitClass before invoking any static method.
+		 *   b) they're not compiled as indirect invocations anyway
+		 */
+		if (!CLASS_GCJ(meth->class)) {
+			return (true);
+		}
+	}
+	return (false);
+}
+
+void *
+engine_buildTrampoline (Method *meth, void **where, errorInfo *einfo)
+{
+	void *ret;
+	methodTrampoline *tramp;
+
+	if (methodNeedsTrampoline(meth)) {
+		/* XXX don't forget to pick those up at class gc time */
+		tramp = (methodTrampoline*)gc_malloc(sizeof(methodTrampoline), KGC_ALLOC_TRAMPOLINE);
+		if (tramp == 0) {
+			postOutOfMemory(einfo);
+			return (0);
+		}
+		FILL_IN_TRAMPOLINE(tramp, meth, where);
+
+		/* a disadvantage of building trampolines individually---as
+		 * opposed to allocating them in a contiguous region---is that
+		 * we have flush the dcache individually for each trampoline
+		 */
+		FLUSH_DCACHE(tramp, tramp+1);
+
+		/* for native gcj methods, we do override their
+		 * anchors so we can patch them up before they're invoked.
+		 */
+		if (!(CLASS_GCJ((meth)->class)
+			&& (meth->accflags & ACC_NATIVE)))
+		{
+			assert(*where == 0 ||
+				!!!"Cannot override trampoline anchor");
+		}
+		ret = tramp;
+	} else {
+		if (CLASS_GCJ((meth)->class)) {
+			METHOD_NATIVECODE(meth) = meth->ncode;
+		}
+		assert(METHOD_NATIVECODE(meth) != 0);
+		ret = METHOD_NATIVECODE(meth);
+	}
+	*where = ret;
+	return ret;
+}
+
+void
+engine_callMethod (callMethodInfo *call)
+{
+	sysdepCallMethod (call);
+}
Index: kaffe/kaffevm/jit/methodcalls.h
===================================================================
RCS file: kaffe/kaffevm/jit/methodcalls.h
diff -N kaffe/kaffevm/jit/methodcalls.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ kaffe/kaffevm/jit/methodcalls.h	7 Aug 2004 09:25:08 -0000
@@ -0,0 +1,30 @@
+
+#ifndef __method_calls_h__
+#define __method_calls_h__
+
+#include "classMethod.h"
+#include "support.h"
+
+/*
+ * Build a trampoline if necessary, return the address of the native code
+ * to either the trampoline or the translated or native code.
+ *
+ * Sets *where to the address of the native code.
+ *
+ * Return the address of the native code or 0 on failure
+ */
+
+void *
+engine_buildTrampoline (Method *meth, void **where, errorInfo *einfo);
+
+
+void
+engine_callMethod (callMethodInfo *call);
+
+/*
+ * extra args the engine wants to pass when using callMethodA / callMethodV
+ */
+#define engine_reservedArgs(M) 0
+
+
+#endif /* __method_dispatch_h__ */
Index: kaffe/kaffevm/jit3/Makefile.am
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/jit3/Makefile.am,v
retrieving revision 1.11
diff -u -r1.11 Makefile.am
--- kaffe/kaffevm/jit3/Makefile.am	27 Jun 2004 12:08:38 -0000	1.11
+++ kaffe/kaffevm/jit3/Makefile.am	7 Aug 2004 09:25:08 -0000
@@ -45,7 +45,9 @@
 	slots.h \
 	stackTrace-impl.h \
 	native-wrapper.c \
-	native-wrapper.h
+	native-wrapper.h \
+	methodcalls.c \
+	methodcalls.h
 
 EXTRA_DIST = \
 	Makefile.frag
Index: kaffe/kaffevm/jit3/Makefile.in
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/jit3/Makefile.in,v
retrieving revision 1.91
diff -u -r1.91 Makefile.in
--- kaffe/kaffevm/jit3/Makefile.in	30 Jul 2004 11:06:25 -0000	1.91
+++ kaffe/kaffevm/jit3/Makefile.in	7 Aug 2004 09:25:09 -0000
@@ -76,7 +76,7 @@
 libengine_la_LIBADD =
 am_libengine_la_OBJECTS = basecode.lo constpool.lo funcs.lo icode.lo \
 	labels.lo machine.lo registers.lo seq.lo slots.lo \
-	native-wrapper.lo
+	native-wrapper.lo methodcalls.lo
 libengine_la_OBJECTS = $(am_libengine_la_OBJECTS)
 DEFAULT_INCLUDES = -I. -I$(srcdir) -I$(top_builddir)/config -I$(top_builddir)/include/kaffe
 depcomp = $(SHELL) $(top_srcdir)/scripts/depcomp
@@ -385,7 +385,9 @@
 	slots.h \
 	stackTrace-impl.h \
 	native-wrapper.c \
-	native-wrapper.h
+	native-wrapper.h \
+	methodcalls.c \
+	methodcalls.h
 
 EXTRA_DIST = \
 	Makefile.frag
@@ -448,6 +450,7 @@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/icode.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/labels.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/machine.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/methodcalls.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/native-wrapper.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/registers.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/seq.Plo@am__quote@
Index: kaffe/kaffevm/jit3/machine.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/jit3/machine.c,v
retrieving revision 1.55
diff -u -r1.55 machine.c
--- kaffe/kaffevm/jit3/machine.c	30 Jul 2004 11:22:46 -0000	1.55
+++ kaffe/kaffevm/jit3/machine.c	7 Aug 2004 09:25:09 -0000
@@ -59,6 +59,7 @@
 #include "mangle.h"
 #include "jvmpi_kaffe.h"
 #include "kaffe_jni.h"
+#include "native-wrapper.h"
 
 char* engine_name = "Just-in-time v3";
 
@@ -135,6 +136,19 @@
 
 /*
  * Translate a method into native code.
+ *
+ * Registers are allocated per basic block, using an LRU algorithm.
+ * Contents of registers are spilled at the end of basic block,
+ * depending on the edges in the CFG leaving the basic block:
+ *
+ * - If there is an edge from the basic block to an exception handler,
+ *   local variables are spilled on the stack
+ *
+ * - If there is only one non-exception edge, and the target basic
+ *   block is following the current block immediately, no spills are done
+ *
+ * - Otherwise, the local variables and the operand stack are spilled
+ *   onto the stack
  */
 jboolean
 translate(Method* xmeth, errorInfo* einfo)
@@ -174,9 +188,12 @@
 
 	/* If this code block is native, then just set it up and return */
 	if ((xmeth->accflags & ACC_NATIVE) != 0) {
-		success = native(xmeth, einfo);
-		if (success == true) {
+		void *func = native(xmeth, einfo);
+		if (func != NULL) {
+			engine_create_wrapper(xmeth, func);
 			KAFFEJIT_TO_NATIVE(xmeth);
+		} else {
+			success = false;
 		}
 		goto done3;
 	}
@@ -1332,8 +1349,6 @@
 /*
  * Include the machine specific trampoline functions.
  */
-#include "trampolines.c"
-
 typedef struct _fakeCall {
 	struct _fakeCall*	next;
 	struct _fakeCall*	parent;
Index: kaffe/kaffevm/jit3/methodcalls.c
===================================================================
RCS file: kaffe/kaffevm/jit3/methodcalls.c
diff -N kaffe/kaffevm/jit3/methodcalls.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ kaffe/kaffevm/jit3/methodcalls.c	7 Aug 2004 09:25:09 -0000
@@ -0,0 +1,3 @@
+
+
+#include "../jit/methodcalls.c"
Index: kaffe/kaffevm/jit3/methodcalls.h
===================================================================
RCS file: kaffe/kaffevm/jit3/methodcalls.h
diff -N kaffe/kaffevm/jit3/methodcalls.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ kaffe/kaffevm/jit3/methodcalls.h	7 Aug 2004 09:25:09 -0000
@@ -0,0 +1,2 @@
+
+#include "../jit/methodcalls.h"
Index: kaffe/kaffevm/jni/jni-callmethod.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/jni/jni-callmethod.c,v
retrieving revision 1.2
diff -u -r1.2 jni-callmethod.c
--- kaffe/kaffevm/jni/jni-callmethod.c	5 Jul 2004 16:40:46 -0000	1.2
+++ kaffe/kaffevm/jni/jni-callmethod.c	7 Aug 2004 09:25:09 -0000
@@ -40,7 +40,7 @@
 		
     return clazz->itable2dtable[implementors[clazz->impl_index] + meth->idx + 1]; 	
   } else {
-    return meth->idx >= 0 ? obj->vtable->method[meth->idx] : METHOD_INDIRECTMETHOD (meth);
+    return meth->idx >= 0 ? obj->vtable->method[meth->idx] : METHOD_NATIVECODE (meth);
   }
 }
 
@@ -119,7 +119,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), obj, args, &retval);
 
   ADD_REF(retval.l);
   END_EXCEPTION_HANDLING();
@@ -154,7 +154,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), obj, args, &retval, 0);
 
   ADD_REF(retval.l);
   END_EXCEPTION_HANDLING();
@@ -178,7 +178,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), obj, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return ((jboolean) retval.i);
@@ -212,7 +212,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), obj, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return ((jboolean) retval.i);
@@ -234,7 +234,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), obj, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return ((jbyte) retval.i);
@@ -268,7 +268,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), obj, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return ((jbyte) retval.i);
@@ -291,7 +291,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), obj, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return ((jchar) retval.i);
@@ -325,7 +325,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), obj, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return ((jchar) retval.i);
@@ -348,7 +348,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), obj, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return ((jshort) retval.i);
@@ -382,7 +382,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), obj, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return ((jshort) retval.i);
@@ -405,7 +405,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), obj, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return (retval.i);
@@ -439,7 +439,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), obj, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return (retval.i);
@@ -995,7 +995,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), obj, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return (retval.j);
@@ -1029,7 +1029,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), obj, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return (retval.j);
@@ -1052,7 +1052,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), obj, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return (retval.f);
@@ -1086,7 +1086,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), obj, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return (retval.f);
@@ -1109,7 +1109,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), obj, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return (retval.d);
@@ -1143,7 +1143,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), obj, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return (retval.d);
@@ -1165,7 +1165,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), obj, args, 0);
+  callMethodV(m, METHOD_NATIVECODE(m), obj, args, 0);
 
   END_EXCEPTION_HANDLING();
 }
@@ -1195,7 +1195,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), obj, args, 0, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), obj, args, 0, 0);
 
   END_EXCEPTION_HANDLING();
 }
@@ -1217,7 +1217,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), 0, args, &retval);
 
   ADD_REF(retval.l);
   END_EXCEPTION_HANDLING();
@@ -1252,7 +1252,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), 0, args, &retval, 0);
 
   ADD_REF(retval.l);
   END_EXCEPTION_HANDLING();
@@ -1276,7 +1276,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), 0, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return ((jboolean) retval.i);
@@ -1310,7 +1310,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), 0, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return ((jboolean) retval.i);
@@ -1333,7 +1333,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), 0, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return ((jbyte) retval.i);
@@ -1367,7 +1367,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), 0, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return ((jbyte) retval.i);
@@ -1390,7 +1390,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), 0, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return ((jchar) retval.i);
@@ -1424,7 +1424,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), 0, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return ((jchar) retval.i);
@@ -1447,7 +1447,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), 0, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return ((jshort) retval.i);
@@ -1481,7 +1481,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), 0, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return ((jshort) retval.i);
@@ -1504,7 +1504,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), 0, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return (retval.i);
@@ -1538,7 +1538,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), 0, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return (retval.i);
@@ -1561,7 +1561,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), 0, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return (retval.j);
@@ -1595,7 +1595,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), 0, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return (retval.j);
@@ -1618,7 +1618,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), 0, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return (retval.f);
@@ -1652,7 +1652,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), 0, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return (retval.f);
@@ -1675,7 +1675,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), 0, args, &retval);
 
   END_EXCEPTION_HANDLING();
   return (retval.d);
@@ -1710,7 +1710,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), 0, args, &retval, 0);
 
   END_EXCEPTION_HANDLING();
   return (retval.d);
@@ -1733,7 +1733,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodV(m, METHOD_INDIRECTMETHOD(m), 0, args, &retval);
+  callMethodV(m, METHOD_NATIVECODE(m), 0, args, &retval);
 
   END_EXCEPTION_HANDLING();
 }
@@ -1763,7 +1763,7 @@
     throwException(NoSuchMethodError(m->name->data));
   }
 
-  callMethodA(m, METHOD_INDIRECTMETHOD(m), 0, args, 0, 0);
+  callMethodA(m, METHOD_NATIVECODE(m), 0, args, 0, 0);
 
   END_EXCEPTION_HANDLING();
 }
Index: kaffe/kaffevm/jni/jni.c
===================================================================
RCS file: /cvs/kaffe/kaffe/kaffe/kaffevm/jni/jni.c,v
retrieving revision 1.6
diff -u -r1.6 jni.c
--- kaffe/kaffevm/jni/jni.c	5 Jul 2004 16:40:47 -0000	1.6
+++ kaffe/kaffevm/jni/jni.c	7 Aug 2004 09:25:10 -0000
@@ -440,7 +440,7 @@
 	}
 	obj = newObject(clazz);
 
-	callMethodV(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval);
+	callMethodV(m, METHOD_NATIVECODE(m), obj, args, &retval);
 
 	ADD_REF(obj);
 	END_EXCEPTION_HANDLING();
@@ -480,7 +480,7 @@
 	}
 	obj = newObject(clazz);
 
-	callMethodA(m, METHOD_INDIRECTMETHOD(m), obj, args, &retval, 0);
+	callMethodA(m, METHOD_NATIVECODE(m), obj, args, &retval, 0);
 
 	ADD_REF(obj);
 	END_EXCEPTION_HANDLING();
